use kube::CustomResource;
use schemars::JsonSchema;
use serde::Deserialize;
use serde::Serialize;
use serde_json::Value;

/// A single execution of a Pipeline.
#[derive(CustomResource, Serialize, Deserialize, Clone, Debug, JsonSchema)]
#[kube(
    group = "tekton.dev",
    version = "v1",
    kind = "PipelineRun",
    singular = "pipelinerun",
    plural = "pipelineruns"
)]
#[kube(namespaced)]
pub struct PipelineRunSpec {
    /// Contents of the Pipeline
    #[serde(default, skip_serializing_if = "Option::is_none")]
    pub pipelineSpec: Option<Value>,

    #[serde(default, skip_serializing_if = "Option::is_none")]
    pub timeouts: Option<Value>,
}
